#ifndef __MSVC__

#include "msvc_strings.h"

int strcpy_s(char *strDestination, size_t sizeOfBuffer, const char *strSource) {
	if (strlen(strSource) < sizeOfBuffer) {
		strcpy(strDestination, strSource);
		return 0;
	} else
		return -1;
}

char * strcpy_s(char *strDestination, const char *strSource) {
	return strcpy(strDestination, strSource);
}

int strncpy_s(char *strDestination, size_t sizeOfBuffer, const char *strSource, size_t count) {
	if (strlen(strSource) < sizeOfBuffer) {
		strncpy(strDestination, strSource, count);
		return 0;
	} else
		return -1;
}

char * strncpy_s(char *strDestination, const char *strSource, size_t count) {
	return strncpy(strDestination, strSource, count);
}

int strcat_s(char *strDestination, size_t sizeOfBuffer, const char *strSource) {
	if ((strlen(strSource) + strlen(strDestination)) < sizeOfBuffer) {
		strcat(strDestination, strSource);
		return 0;
	} else
		return -1;
}

char * strcat_s(char *strDestination, const char *strSource) {
	return strcat(strDestination, strSource);
}

#endif
